/*
    LPE: Encode a TGA to an LP file allowing the user 
    to specify quantization parameters

    05/01/97 JSP Creation
*/

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>

#include "lp.h"
#include "tga.h"

enum { LEVELS = 5 };

main (int argc, char **argv)
{
    try
    {
        if (argc < 3)
            throw "usage: test1 <tga filename> <lp filename> [bpp0 [bpp1 [bpp2 [bpp3 [bpp4]]]]]";

        cout << endl << argv[1] << ": " << flush;

        TGA tga;

        tga.Load (argv[1]);

        cout << tga.Width () << " X " << tga.Height ()
            << " greyscale image" << endl;

        unsigned bpp[LEVELS] = {3, 4, 6, 7, 8};

        for (int arg = 3; arg < argc; arg++)
            bpp[arg - 3] = atoi (argv[arg]);

        cout << "Pyramid levels: " << (int) LEVELS << endl;
        cout << "Quantization bpp: ";

        for (int index = 0; index < 5; index++)
            cout << bpp[index] << " ";

        cout << endl;

        LP lp (tga.Width (), 
            tga.Height (), 
            (unsigned char *) tga.Image (), 
            LEVELS,
            bpp);

        lp.Compress ();
        lp.Quantize ();

        cout << "Entropy: " << lp.Entropy () << " bpp" << endl << endl;

        cout << "Saving " << argv[2] << endl;

        lp.Save (argv[2]);

        return 0;
    }
    catch (const char *e)
    {
        cerr << e << endl;

        return -1;
    }
}